(* Valeurs de réponse pour le sujet de khölle *)

if Array.length Sys.argv < 2
     then raise ( Invalid_argument "Un u0 est demandé" ) ;;
let u0 = int_of_string Sys.argv.(1) ;;

                                (* Question 3 *)

let rec u ( n : int ) : int =
  if n == 0 then u0 else 15091 * (u ( n - 1) ) mod 64007 ;;

Printf.printf "Question 3 : a) %i , b) %i , c) %i \n" (u 30) (u 300) (u 3000) ;;

                                (* Question 4 *)

let v ( k : int ) ( l : int ) : Entiers.entier =
  let rec remplissage ( i : int ) : Entiers.entier = if i == l + 1 then []
    else ( ( u ( k * l + i ) ) mod 10 ) :: remplissage ( i + 1 ) in
  remplissage 1 ;;

let entier_vers_string ( n : Entiers.entier ) : string =
  let caracteres ( i : int ) : char =
    Char.chr ( ( List.nth n ( ( List.length n ) - i - 1 ) ) + ( Char.code '0' ) )  in
  String.init ( List.length n ) caracteres ;;

type signature = int * int * int
let ma_sig ( n : Entiers.entier ) : signature =
  let rec calcul_signature ( n : Entiers.entier )  ( n3 : int ) ( n5 : int ) ( n7 : int )
    : signature =
    match n with
    | [] -> ( n3, n5, n7 )
    | chiffre :: suite -> calcul_signature suite
        ( if chiffre == 3 then n3 + 1 else n3  )
        ( if chiffre == 5 then n5 + 1 else n5  )
        ( if chiffre == 7 then n7 + 1 else n7  ) in
  calcul_signature n 0 0 0 ;;

let n3_1, n5_1, n7_1 = ma_sig ( v 2 50 ) in
let n3_2, n5_2, n7_2 = ma_sig ( v 10 500 ) in
Printf.printf "Question 4 : a) %s , b) ( %i, %i, %i ) , c) ( %i, %i, %i ) \n"
  ( entier_vers_string ( v 1 5 ) ) n3_1 n5_1 n7_1 n3_2 n5_2 n7_2 ;;

                                (* Question 5 *)

let max ( l : Entiers.entier list ) : Entiers.entier =
  let rec max_interdmediaire
      ( l : Entiers.entier list )
      ( max : Entiers.entier )
    : Entiers.entier = match l with
    | [] -> max
    | n :: suite -> max_interdmediaire suite
                      ( if Entiers.est_plus_grand n max then n else max ) in
  match l with
  | [] -> raise ( Invalid_argument "Liste vide" )
  | n :: suite -> max_interdmediaire suite n ;;

let suite_S ( n : int ) ( l : int ) : Entiers.entier list =
  let rec remplissage ( i : int ) ( acc : Entiers.entier list ) =
    if i == 0 then acc else remplissage ( i-1 ) ( ( v ( i - 1 ) l ) :: acc ) in
  remplissage n [] ;;

let n3_1, n5_1, n7_1 = ma_sig ( max ( suite_S 10 10 ) ) in
let n3_2, n5_2, n7_2 = ma_sig ( max ( suite_S 100 100 ) ) in
let n3_3, n5_3, n7_3 = ma_sig ( max ( suite_S 200 200 ) ) in
Printf.printf "Question 5 : a) ( %i, %i, %i ) , b) ( %i, %i, %i ) , c) ( %i, %i, %i ) \n"
  n3_1 n5_1 n7_1 n3_2 n5_2 n7_2 n3_3 n5_3 n7_3 ;;

                                (* Question 6 *)
let n3_1, n5_1, n7_1 = ma_sig ( Entiers.addition ( v 1 50 ) ( v 2 50 ) ) in
let n3_2, n5_2, n7_2 = ma_sig ( Entiers.addition ( v 1 100 ) ( v 2 100 ) ) in
let n3_3, n5_3, n7_3 = ma_sig ( Entiers.addition ( v 1 500 ) ( v 2 500 ) ) in
Printf.printf "Question 6 : a) ( %i, %i, %i ) , b) ( %i, %i, %i ) , c) ( %i, %i, %i ) \n"
  n3_1 n5_1 n7_1 n3_2 n5_2 n7_2 n3_3 n5_3 n7_3 ;;

                                (* Question 7 *)
let n3_1, n5_1, n7_1 = ma_sig ( Entiers.soustraction ( v 1 10 ) ( v 2 10 ) ) in
let n3_2, n5_2, n7_2 = ma_sig ( Entiers.soustraction ( v 1 50 ) ( v 2 50 ) ) in
let n3_3, n5_3, n7_3 = ma_sig ( Entiers.soustraction ( v 1 500 ) ( v 2 500 ) ) in
Printf.printf "Question 7 : a) ( %i, %i, %i ) , b) ( %i, %i, %i ) , c) ( %i, %i, %i ) \n"
  n3_1 n5_1 n7_1 n3_2 n5_2 n7_2 n3_3 n5_3 n7_3 ;;

                                (* Question 8 *)
let n3_1, n5_1, n7_1 = ma_sig ( Entiers.multiplication ( v 1 128 ) ( v 2 128 ) ) in
let n3_2, n5_2, n7_2 = ma_sig ( Entiers.multiplication ( v 1 256 ) ( v 2 256 ) ) in
let n3_3, n5_3, n7_3 = ma_sig ( Entiers.multiplication ( v 1 512 ) ( v 2 512 ) ) in
Printf.printf "Question 8 : a) ( %i, %i, %i ) , b) ( %i, %i, %i ) , c) ( %i, %i, %i ) \n"
  n3_1 n5_1 n7_1 n3_2 n5_2 n7_2 n3_3 n5_3 n7_3 ;;

                                (* Question 9 *)
let n3_1, n5_1, n7_1 = ma_sig ( Entiers.multiplication ( v 1 100 ) ( v 2 200 ) ) in
let n3_2, n5_2, n7_2 = ma_sig ( Entiers.multiplication ( v 1 50 ) ( v 2 100 ) ) in
let n3_3, n5_3, n7_3 = ma_sig ( Entiers.multiplication ( v 1 128 ) ( v 2 512 ) ) in
Printf.printf "Question 9 : a) ( %i, %i, %i ) , b) ( %i, %i, %i ) , c) ( %i, %i, %i ) \n"
  n3_1 n5_1 n7_1 n3_2 n5_2 n7_2 n3_3 n5_3 n7_3 ;;

                                (* Question 1à *)
let n3_1, n5_1, n7_1 = ma_sig ( Entiers.pow_entier ( v 1 50 ) 144 ) in
let n3_2, n5_2, n7_2 = ma_sig ( Entiers.pow_entier ( v 1 100 ) 21 ) in
let n3_3, n5_3, n7_3 = ma_sig ( Entiers.pow_entier ( v 1 150 ) 12 ) in
Printf.printf "Question 10 : a) ( %i, %i, %i ) , b) ( %i, %i, %i ) , c) ( %i, %i, %i ) \n"
  n3_1 n5_1 n7_1 n3_2 n5_2 n7_2 n3_3 n5_3 n7_3 ;;
